<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import { CtfCard } from '~/models';

import { NextStepAlt, PricingBanner } from '~/components/common/index.vue';
import {
  CaseStudyCarousel,
  FeaturesBlock,
  GuestCalculator,
  NoImageAccordion,
  PlanSummary,
  RoiCalculatorBlock,
} from '~/components/pricing/plans/index.vue';
import { BySolutionValueProp } from '~/components/solutions/by-solution/index.vue';
import { EducationCaseStudyCarousel } from '~/components/solutions/education/index.vue';
import { getClient } from '~/plugins/contentful.js';
import { CONTENT_TYPES } from '~/common/content-types';
import { convertToCaseSensitiveLocale } from '~/common/util';
export default Vue.extend({
  components: {
    PlanSummary,
    NoImageAccordion,
    CaseStudyCarousel,
    RoiCalculatorBlock,
    FeaturesBlock,
    NextStepAlt,
    GuestCalculator,
    BySolutionValueProp,
    EducationCaseStudyCarousel,
    PricingBanner,
  },
  async asyncData({ $content, params, i18n }: any) {
    try {
      const locale = i18n.locale;
      const doc = await $content(
        locale,
        `pricing/${params.pricing ? params.pricing : 'index'}`,
      ).fetch();

      if (params.pricing === 'premium') {
        const { items } = await getClient().getEntries({
          content_type: CONTENT_TYPES.CARD,
          'sys.id': 'kqL2YlpE6UQRonQDWdSZF',
          locale: convertToCaseSensitiveLocale(i18n.locale),
        });

        const smbBanner: CtfCard = {
          internalName: items[0].fields.internalName,
          title: items[0].fields.title,
          button: items[0].fields.button && items[0].fields?.button?.fields,
        };

        doc.banner = smbBanner;
      }

      // features
      const relatedContent = await $content(
        `shared/en-us/features/related-data`,
      ).fetch();
      let featuresContent = await $content('synced/features').fetch();
      featuresContent = featuresContent.features;

      if (params.pricing === 'ultimate') {
        featuresContent = featuresContent.filter(
          (feature: any) => feature.gitlab_ultimate && !feature.gitlab_premium,
        );
      } else if (params.pricing === 'premium') {
        featuresContent = featuresContent.filter(
          (feature: any) => feature.gitlab_premium && !feature.gitlab_core,
        );
      }

      return { doc, relatedContent, featuresContent, locale };
    } catch (e) {
      throw new Error(e);
    }
  },
  data() {
    return {
      completed: false,
    };
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).doc,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  mounted() {
    this.completed = true;
  },
});
</script>

<template>
  <div class="pricing-plan">
    <script src="//page.gitlab.com/js/forms2/js/forms2.min.js"></script>
    <PricingBanner v-if="doc.banner" v-bind="doc.banner" />
    <SlpContainer class="pricing-plan__wrapper">
      <SlpSideNavigation :data="doc.side_menu">
        <template #header>
          <div class="pricing-plan__nav-buttons">
            <SlpButton
              v-for="(button, buttonIndex) in doc.side_menu.hyperlinks.data"
              :key="buttonIndex"
              :variant="button.variant"
              :href="button.href"
              :data-ga-name="button.data_ga_name"
              :data-ga-location="button.data_ga_location"
              >{{ button.text }}
              <SlpIcon
                v-if="button.icon"
                class="slp-ml-8"
                name="chevron-lg-right"
                variant="product"
                alt="Chevron Right Icon"
              />
            </SlpButton>
          </div>
        </template>
        <div id="overview" class="pricing-plan__content">
          <component
            :is="component.name"
            v-for="component in doc.components"
            :key="component.name"
            :data="component.data"
          />
          <!-- If English, pass the featuresContent data into this component. Any other locale is hidden -->
          <FeaturesBlock
            v-if="completed"
            :data="doc.features_block"
            :features="locale === 'en-us' ? featuresContent : null"
            :related-content="relatedContent"
          />
        </div>
      </SlpSideNavigation>
      <SlpSideButton data-ga-name="to-top" data-ga-location="body" />
    </SlpContainer>
    <NextStepAlt />
  </div>
</template>

<style scoped lang="scss">
.pricing-plan {
  overflow: clip;

  @media (min-width: $breakpoint-md) {
    &__wrapper {
      margin-top: $spacing-96;
    }
    :deep {
      #collapsible-sidebar-content {
        max-width: calc(100% - 300px);
      }
    }
  }

  &__nav-buttons {
    margin-bottom: $spacing-24;
    .slp-btn {
      width: 100%;
      justify-content: center;
      margin-bottom: $spacing-8;
    }

    .slp-btn-secondary {
      padding: 11px 0;
    }
  }

  // sidenav is on mobile view
  @media (max-width: $breakpoint-md) {
    &:deep {
      .dropdown {
        margin: $spacing-32 0;
      }
      .slp-top-btn {
        display: none;
      }
    }
  }
}
</style>
